/*
 * TOFU Circuit Simulator
 * Copyright (C) 2007 Michael Birken
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
 * 
 * http://www.meatfighter.com/tofu
 */

package tofu.harryporter;

import tofu.*;
import java.util.*;

public class Halter extends Component {
  
  private Node inputNode;
  private static List<IBulb> bulbs = new ArrayList<IBulb>();
  
  public static void addBulb(IBulb bulb) {
    bulbs.add(bulb);
  }
   
  public void init() {
    inputNode = getNode("input");
  }
  
  public void update() {
    if (inputNode.getVoltage() == Voltage.H) {
      Collections.sort(bulbs);
      for(IBulb bulb : bulbs) {
        bulb.print();
      }
      System.exit(0);
    }
  }

  public void flow() {
  }  
}
